// Generated by dts-bundle v0.7.3
// Dependencies for this module:
//   ../flux
//   ../react
//   ../hoist-non-react-statics

declare module 'GeneralStore' {
    import * as DispatcherInstance from 'GeneralStore/dispatcher/DispatcherInstance';
    import * as InspectStore from 'GeneralStore/store/InspectStore';
    import StoreSingleton from 'GeneralStore/store/StoreSingleton';
    import StoreFactory from 'GeneralStore/store/StoreFactory';
    export function define<T>(): StoreSingleton<T>;
    export function defineFactory<T>(): StoreFactory<T>;
    export { StoreFactory };
    export { default as connect } from 'GeneralStore/dependencies/connect';
    export { default as connectCallback } from 'GeneralStore/dependencies/connectCallback';
    export { default as useStoreDependency, } from 'GeneralStore/dependencies/useStoreDependency';
    export { DispatcherInstance, InspectStore };
}

declare module 'GeneralStore/dispatcher/DispatcherInstance' {
    import { Dispatcher } from 'flux';
    export function get(): Dispatcher<any> | null;
    export function set(dispatcher: Dispatcher<any>): void;
    export function clear(): Dispatcher<any>;
}

declare module 'GeneralStore/store/InspectStore' {
    import { Dispatcher } from 'flux';
    import { StoreResponses } from 'GeneralStore/store/Store';
    import StoreFactory from 'GeneralStore/store/StoreFactory';
    import Store from 'GeneralStore/store/Store';
    export function getActionTypes(store: Store<any>): Array<string>;
    export function getDispatcher(store: Store<any>): Dispatcher<any>;
    export function getDispatchToken(store: Store<any>): string;
    export function getGetter<T>(store: Store<T>): (...args: Array<any>) => T;
    export function getId(store: Store<any>): string;
    export function getFactory<T>(store: Store<T>): StoreFactory<T>;
    export function getName(store: Store<any>): string;
    export function getResponses(store: Store<any>): StoreResponses<any>;
    export function getState<T>(store: Store<T>): T;
    export function isStore(store: any): boolean;
}

declare module 'GeneralStore/store/StoreSingleton' {
    import { Dispatcher } from 'flux';
    import Store from 'GeneralStore/store/Store';
    import StoreFactory from 'GeneralStore/store/StoreFactory';
    export default class StoreSingleton<T> {
        _facade?: Store<T>;
        _factory: StoreFactory<T>;
        _getter?: Function;
        constructor();
        defineGet(getter: () => any): StoreSingleton<T>;
        defineName(name: string): StoreSingleton<T>;
        defineResponseTo(actionTypes: Array<string> | string, response: (data: any) => void): StoreSingleton<T>;
        isRegistered(): boolean;
        register(dispatcher?: Dispatcher<any>): Store<T>;
    }
}

declare module 'GeneralStore/store/StoreFactory' {
    import { Dispatcher } from 'flux';
    import Store, { StoreGetter, StoreResponses, StoreResponse } from 'GeneralStore/store/Store';
    export type StoreFactoryDefinition<T> = {
        getter?: StoreGetter<T>;
        getInitialState?: StoreGetter<T>;
        name?: string;
        responses?: StoreResponses<T>;
    };
    export default class StoreFactory<T> {
        _definition: StoreFactoryDefinition<T>;
        constructor({ getter, getInitialState, name, responses, }?: StoreFactoryDefinition<T>);
        defineGet(getter: StoreGetter<T>): StoreFactory<T>;
        defineGetInitialState(getInitialState: StoreGetter<T>): StoreFactory<T>;
        defineName(name: string): StoreFactory<T>;
        defineResponses(newResponses: StoreResponses<T>): StoreFactory<T>;
        defineResponseTo(actionTypes: string | Array<string>, response: StoreResponse<T>): StoreFactory<T>;
        getDefinition(): StoreFactoryDefinition<T>;
        register(dispatcher?: Dispatcher<any>): Store<T>;
    }
}

declare module 'GeneralStore/dependencies/connect' {
    import { DependencyMap, DependencyMapProps } from 'GeneralStore/dependencies/DependencyMap';
    import { Dispatcher } from 'flux';
    import * as React from 'react';
    import { RefObject } from 'react';
    export function useCurrent<ValueType>(value: ValueType): RefObject<ValueType>;
    export default function connect<Deps extends DependencyMap>(dependencies: Deps, dispatcher?: Dispatcher<any>): <C extends any, Props extends DependencyMapProps<Deps>>(BaseComponent: React.ComponentType<Props>) => any;
}

declare module 'GeneralStore/dependencies/connectCallback' {
    import { DependencyMap } from 'GeneralStore/dependencies/DependencyMap';
    import { Dispatcher } from 'flux';
    export default function connectCallback(dependencies: DependencyMap, dispatcher?: Dispatcher<any>): any;
}

declare module 'GeneralStore/dependencies/useStoreDependency' {
    import { Dispatch, RefObject, SetStateAction } from 'react';
    import { Dependency, DependencyMap, GetDependencyType } from 'GeneralStore/dependencies/DependencyMap';
    import { Dispatcher } from 'flux';
    export function useCurrent<ValueType>(value: ValueType): RefObject<ValueType>;
    export function _useDispatchSubscription<Props, DependencyMapType extends DependencyMap, DependenciesType = {
        [key in keyof DependencyMapType]: GetDependencyType<DependencyMapType[key]>;
    }>(dependencyMap: DependencyMapType, currentProps: RefObject<Props>, dispatcher: Dispatcher<any>, dependencyValue: DependenciesType, setDependencyValue: Dispatch<SetStateAction<DependenciesType>>): void;
    function useStoreDependency<Props, DepType>(dependency: Dependency<DepType>, props?: Props, dispatcher?: Dispatcher<any>): DepType;
    export default useStoreDependency;
}

declare module 'GeneralStore/store/Store' {
    import { Dispatcher } from 'flux';
    import StoreFactory from 'GeneralStore/store/StoreFactory';
    import Event from 'GeneralStore/event/Event';
    import EventHandler from 'GeneralStore/event/EventHandler';
    global {
            interface Window {
                    __REDUX_DEVTOOLS_EXTENSION__: DevToolsExtension;
            }
    }
    export type Action = {
            actionType: string;
            type: string;
            data: any;
            payload: any;
    };
    export type StoreGetter<T> = (...args: Array<any>) => T;
    export type StoreResponse<T> = (state: T, data: any, actionType: string, payload: Action) => any;
    export type StoreResponses<T> = {
            [key: string]: StoreResponse<T>;
    };
    export type StoreOptions<T> = {
            dispatcher: Dispatcher<any>;
            factory: StoreFactory<T>;
            getter: StoreGetter<T>;
            initialState: T;
            name?: string;
            responses: StoreResponses<T>;
    };
    type DevToolsOptions = {
            name: string;
            instanceId: string;
    };
    type DevToolsMessage = {
            type: string;
            state: any;
            payload: DevToolsMessage;
    };
    type DevToolsExtension = {
            connect: (options: DevToolsOptions) => DevToolsExtension;
            send: (message: string, data: any) => any;
            unsubscribe: () => any;
            subscribe: (callback: (message: DevToolsMessage) => void) => any;
    };
    export default class Store<T> {
            _dispatcher: Dispatcher<any>;
            _dispatchToken: string;
            _factory: StoreFactory<T>;
            _getter: StoreGetter<T>;
            _event: Event;
            _name: string;
            _responses: StoreResponses<T>;
            _state: any;
            _uid: string;
            _devToolsExtension: DevToolsExtension;
            _unsubscribeDevTools?: () => any;
            constructor({ dispatcher, factory, getter, initialState, name, responses, }: StoreOptions<T>);
            /**
                * Subscribe to changes on this store.
                *
                * @param  callback  will run every time the store responds to a dispatcher
                * @return this
                */
            addOnChange(callback: Function): EventHandler;
            /**
                * Returns the store's referenced value
                *
                * @param  ...  accepts any number of params
                * @return any
                */
            get(...args: any[]): T;
            /**
                * @protected
                * Responds to incoming messages from the Dispatcher
                */
            _handleDispatch(payload: Action): void;
            /**
                * Destroys this instance of the store.
                * Dispatch callback is unregistered. Subscriptions are removed.
                */
            remove(): void;
            toString(): string;
            /**
                * Runs all of the store's subscription callbacks
                *
                * @return this
                */
            triggerChange(): Store<T>;
    }
    export {};
}

declare module 'GeneralStore/dependencies/DependencyMap' {
    import { ComponentType } from 'react';
    import Store from 'GeneralStore/store/Store';
    import hoistStatics from 'hoist-non-react-statics';
    export type CompoundDependency<T> = {
        propTypes?: Object;
        stores: Store<any>[];
        deref: (props?: Object, state?: Object, stores?: Store<any>[]) => T;
    };
    export type Dependency<T> = CompoundDependency<T> | Store<T>;
    export type DependencyIndexEntry = {
        dispatchTokens: {
            [key: string]: boolean;
        };
        fields: {
            [key: string]: boolean;
        };
    };
    export type DependencyIndex = {
        [key: string]: DependencyIndexEntry;
    };
    export type DependencyMap = {
        readonly [key: string]: Dependency<any>;
    };
    export type GetProps<C> = C extends ComponentType<infer P> ? P extends {} ? P : never : never;
    export type GetDependencyType<D> = D extends Dependency<infer T> ? T : never;
    export type DependencyMapProps<DM extends DependencyMap> = DM extends DependencyMap ? {
        [key in keyof DM]: GetDependencyType<DM[key]>;
    } : never;
    export type ConnectedComponentType<P, C> = React.ForwardRefExoticComponent<P & C> & {
        WrappedComponent: C;
        dependencies: DependencyMap;
    } & hoistStatics.NonReactStatics<P & C>;
    export type PropTypes = {
        [key: string]: Function;
    };
    export function enforceValidDependencies(dependencies: DependencyMap): DependencyMap;
    export function dependencyPropTypes(dependencies: DependencyMap, existingPropTypes?: {
        [key: string]: Function;
    }): PropTypes;
    export function calculate<Props, State, DerefValue>(dependency: Dependency<DerefValue>, props?: Props, state?: State): DerefValue;
    export function calculateInitial<Props, State, Deps extends DependencyMap>(dependencies: Deps, props: Props, state?: State): {
        [key in keyof Deps]: GetDependencyType<Deps[key]>;
    };
    export function calculateForDispatch<Props, State, Deps extends DependencyMap>(dependencies: Deps, dependencyIndexEntry: DependencyIndexEntry, props: Props, state?: State): {
        [key in keyof Deps]: Deps[key];
    };
    export function makeDependencyIndex(dependencies: DependencyMap): DependencyIndex;
}

declare module 'GeneralStore/event/Event' {
    import EventHandler from 'GeneralStore/event/EventHandler';
    export default class Event {
            _handlers: {
                    [key: string]: Function;
            };
            constructor();
            /**
                * Add a subscription to this event
                *
                * @param  callback  run when the event is triggered.
                * @return this
                */
            addHandler(callback: Function): EventHandler;
            /**
                * Destroys this event. Removes all handlers.
                *
                * @return this
                */
            remove(): Event;
            /**
                * Removes a subscription by key.
                *
                * @param  key   id of the subscription to remove
                * @return this
                */
            removeHandler(key: string): Event;
            /**
                * @protected
                * Run a handler by key if it exists
                *
                * @param  key  id of the handler to run
                */
            _runHandler(key: string): void;
            /**
                * Run all subscribed handlers.
                *
                * @return this
                */
            runHandlers(): Event;
            /**
                * Convenience method for running multiple events.
                *
                * @param  events  a list of events to run.
                */
            static runMultiple(events: Array<Event>): void;
    }
}

declare module 'GeneralStore/event/EventHandler' {
    import Event from 'GeneralStore/event/Event';
    export default class EventHandler {
        _key: string;
        _instance?: Event;
        constructor(instance: Event, key: string);
        getKey(): string;
        remove(): void;
    }
}

